program friendship_and_kefir;

{$APPTYPE CONSOLE}

type 
  arcinfoptr = ^arcinfo;
  arcinfo = record
    dest: integer;
    next: arcinfoptr;
  end; 

const 
  nmax = 600;

var
  arcs: array[0..nmax] of arcinfoptr;
  cola: array[0..nmax] of boolean;
  deg, neib, curneib, queue: array[0..nmax] of integer;
  a, b, min, i, j, n, m, t, w: integer;
  temparc: arcinfoptr;

procedure pusharc(a, b: integer);
var temparc: arcinfoptr;
begin
  new(temparc);
  temparc.dest := b;
  temparc.next := arcs[a];
  arcs[a] := temparc;
  inc(deg[a]); if cola[b] then inc(curneib[a]);
end;

procedure poparc(a: integer);
var temparc: arcinfoptr;
begin
  temparc := arcs[a];
  arcs[a] := arcs[a].next;
  dispose(temparc);  
  dec(deg[a]);
end;

function bfs: integer;
var temparc: arcinfoptr;
    lb, ub, i: integer;
begin
  lb := 0; ub := 0; result := w;
  for i := 1 to n do 
    if (2*curneib[i]>deg[i]) and (not cola[i]) then 
    begin
      inc(ub); 
      queue[ub] := i;
    end;
  while ub <> lb do 
  begin
    inc(lb); inc(result); 
    temparc := arcs[queue[lb]];
    while temparc <> nil do 
    begin
      inc(curneib[temparc.dest]);
      if ((2*curneib[temparc.dest])>deg[temparc.dest]) and 
         ((2*(curneib[temparc.dest] - 1))<=deg[temparc.dest]) and
         (not cola[temparc.dest]) then 
      begin
        inc(ub);
        queue[ub] := temparc.dest;
      end;
      temparc := temparc.next;
    end; 
  end;
end;

begin
  assign (input, 'input.txt'); reset (input);
  assign (output, 'output.txt'); rewrite (output);

  read(n);
  for i := 1 to n do begin read(m); cola[i] := (m = 1); inc(w, m); end;
  read(m);
  for i := 1 to m do 
  begin
    read (a, b);
    pusharc(a, b);
    pusharc(b, a);
  end;
  neib := curneib;
//  for i := 1 to n do neib[i] := curneib[i];

  a := -1; b := -1; min := bfs;
  for i := 1 to n do 
    for j := i + 1 to n do 
    begin
      temparc := arcs[i];
      while (temparc <> nil) and (temparc.dest <> j) do temparc := temparc.next;
      if (temparc = nil) then 
      begin 
        curneib := neib;
//        for t := 1 to n do curneib[t] := neib[t];
        pusharc(i, j); pusharc(j, i);
        t := bfs;
        poparc(i); poparc(j);
        if t < min then begin min := t; a := i; b := j; end;  
      end;
    end;

  if a = -1 then write (-1) else write(a, ' ', b);

  close (input); close (output);
end.
